/*
*
* Galaxytool Javascripts
* (c) 2005-2008 Christian Lehmann
* mail: webmaster@mathe-informatik.de
* www: http://www.galaxytool.eu
*
* Requires: common_scripts.js
*
*/

/*
* Content for Ajax - reloading of required information and making entries visible
*/

var mouse_x = 0;
var mouse_y = 0;
var mouse_down = false;

var content_open = false;
var content_buffer = new Array();
var hide_unhide_buffer = new Array();
var temp_object = "";
var value_help_object = "";
var source_url = "";
var current_object = "";
var current_object_cached = true;
var start_time = 0;
var active; // object for timer
var timeout_start_mouse_x;
var timeout_start_mouse_y;

var docElement =  ( typeof document.compatMode != "undefined" &&  document.compatMode != "BackCompat") ? "documentElement" : "body";

/*
* Start event handler to have mouse coordinates
*/
function Init() {
	document.onmousemove =	set_mouse_pos;
	document.onclick     =	MouseReleased;
	document.onmousedown =	MousePressed;
	try {
		standardistaTableSorting.init();
	} catch(e) {
		// will be removed once report search works with dojo tables
	}
}

/*
* This method will be called every time the mouse pos changes
*/
function set_mouse_pos(e) {
	var mouse_old_x = mouse_x;
	var mouse_old_y = mouse_y;

	mouse_x = (document.all) ? window.event.x + document.body.scrollLeft : e.pageX;
	mouse_y = (document.all) ? window.event.y + document.body.scrollTop  : e.pageY;
	
	// check if window shall be moved
	if (current_object != "" && mouse_down == true) {
		// check if mouse is inside our current object that shall be moved
		var move_x = mouse_x - mouse_old_x;
		var move_y = mouse_y - mouse_old_y;
		document.getElementById(current_object).style.top     = document.getElementById(current_object).offsetTop  + move_y;
		document.getElementById(current_object).style.left    = document.getElementById(current_object).offsetLeft + move_x;

		return;
	}

	// check if mouse_x and mouse_y are still bound, otherwise close opened object
	if (current_object != "" && current_object_cached == true) {
		var top_left_x = document.getElementById(current_object).offsetLeft;
		var top_left_y = document.getElementById(current_object).offsetTop;
		var lower_right_x = document.getElementById(current_object).offsetLeft + document.getElementById(current_object).offsetWidth;
		var lower_right_y = document.getElementById(current_object).offsetTop + document.getElementById(current_object).offsetHeight;

		// check for - 30 from the left and top to the end of the element
		if ( mouse_x < top_left_x - 30 || mouse_x > lower_right_x +30 ||
		mouse_y < top_left_y - 30 || mouse_y > lower_right_y + 30 ) {
			removeObjects();
		}
	}
}

/*
* This method stores all required information and calls the updateObjects() method
* after 500 milliseconds timeout.
*/
function ShowObject(param_object,param_url,caching) {
	source_url = param_url;
	temp_object = param_object;
	timeout_start_mouse_x = mouse_x;
	timeout_start_mouse_y = mouse_y;
	window.clearTimeout(active);
	if (caching == true) {
		current_object_cached = true;
		active = setTimeout("updateObjects('true')",500);
	} else {
		current_object_cached = false;
		active = setTimeout("updateObjects('false')",500);
	}
}

function ShowValueHelp(param_object,param_url,source_object) {
	source_url = param_url;
	value_help_object = param_object;
	window.clearTimeout(active);
	active = setTimeout("updateValueHelp('"+source_object+"')",500);
}

/*
* If the mouse is still in valid range (+-20 px of mouseoverpos)
* check if the content was loaded before and make it visible again
* otherwise load the content and make it visible
*/
function updateObjects(caching) {
	// if object is already opened, quit
	if (content_open == true && caching == true) {
		return;
	}
	window.clearTimeout(active);

	removeObjects();

	// check if mouse was moved during timeout
	if (caching == true && (mouse_x < timeout_start_mouse_x - 20 || mouse_x > timeout_start_mouse_x + 20 ||
	mouse_y < timeout_start_mouse_y - 20 || mouse_y > timeout_start_mouse_y + 20 )) {
		return;
	}

	// determine position of object
	// check if content was already loaded
	if (caching == true) {
		for (var i=0; i< content_buffer.length; i++) {
			if (content_buffer[i] == temp_object) {
				document.getElementById(temp_object).style.display = "inline";
				if (mouse_y > document.getElementById(temp_object).offsetHeight) {
					document.getElementById(temp_object).style.top     = mouse_y-10- document.getElementById(temp_object).offsetHeight;
				} else {
					document.getElementById(temp_object).style.top     = mouse_y+10;
				}
				if (mouse_x > document.getElementById(temp_object).offsetWidth) {
					document.getElementById(temp_object).style.left    = mouse_x - 10 - document.getElementById(temp_object).offsetWidth;
				} else {
					document.getElementById(temp_object).style.left    = mouse_x + 10;
				}
				current_object = temp_object;
				return;
			}
		}
	}

	document.getElementById("loading").style.display = "inline";
	document.getElementById("loading").style.top     = mouse_y+10;
	document.getElementById("loading").style.left    = mouse_x+10;
	advAJAX.get({
		url : source_url,
		onSuccess : function(obj) {
			document.getElementById(temp_object).innerHTML     = obj.responseText;
			
			// workaround to make wz_toolip work also in new popup content loaded to HTML page
			try {
				var wz_tooltip = document.getElementById("wz_tooltip");
				// delete old tooltips (if they exist at all)
				try {
					document.getElementsByTagName("body")[0].removeChild(document.getElementById("wz_tooltips"));
				} catch(no_tooltips) {
					// no tooltip exists
				}
				
				wz_tooltip.removeChild(wz_tooltip.firstChild);
		       // To add: <script type="text/javascript" src="wz_tooltip.js">
				var my_element = document.createElement("script");
		        var my_attribute = document.createAttribute("type");
		        my_attribute.nodeValue = "text/javascript";
		        my_element.setAttributeNode(my_attribute);
		        my_attribute = document.createAttribute("src");
		        my_attribute.nodeValue = "wz_tooltip.js";
		        my_element.setAttributeNode(my_attribute);
				wz_tooltip.appendChild(my_element);
				
				 
				try {
					dojo.require("dojo.parser"); 
					dojo.parser.parse(temp_object);
					dojo.query(".startsHidden")
					.style("opacity", 100)
					.removeClass("startsHidden")
					;
				} catch(no_dojo) {
					// no dojo loaded
				}

				
			} catch(e) {
				alert("Error during deletion of wz_tooltip: "+e);
			}			
			
			
			document.getElementById("loading").style.display   = "none";
			document.getElementById(temp_object).style.display = "inline";
			if (mouse_y > document.getElementById(temp_object).offsetHeight) {
				document.getElementById(temp_object).style.top     = mouse_y-10- document.getElementById(temp_object).offsetHeight;
			} else {
				document.getElementById(temp_object).style.top     = mouse_y+10;
			}
			if (mouse_x > document.getElementById(temp_object).offsetWidth) {
				document.getElementById(temp_object).style.left    = mouse_x - 10 - document.getElementById(temp_object).offsetWidth;
			} else {
				document.getElementById(temp_object).style.left    = mouse_x + 10;
			}
			content_open = true;
			if (caching == true) {
				content_buffer.push(temp_object);
			}
			current_object = temp_object;
		},
		onError : function(obj) { alert("Error: " + obj.status); }
	});
		
}

function updateValueHelp(source_object) {
	window.clearTimeout(active);
	removeObjects();

	// determine position of object
	document.getElementById(value_help_object).style.left = getAbsolutePosition(document.getElementById(source_object)).x;
	document.getElementById(value_help_object).style.top  = getAbsolutePosition(document.getElementById(source_object)).y + document.getElementById(source_object).offsetHeight;

	advAJAX.get({
		url : source_url,
		onSuccess : function(obj) {
			document.getElementById(value_help_object).innerHTML     = obj.responseText;
			document.getElementById(value_help_object).style.display = "inline";
		},
		onError : function(obj) { alert("Error: " + obj.status); }
	});
}

/*
* set diplay: none to all possible objects
*/
function removeObjects() {
	// remove all objects from buffer
	for (var i=0; i< content_buffer.length; i++) {
		document.getElementById(content_buffer[i]).style.display = "none";
	}
	// remove other possible objects which are not buffered - like popup
	if (current_object != "") {
		document.getElementById(current_object).style.display = "none";
	}
	if (value_help_object != "") {
		document.getElementById(value_help_object).style.display = "none";
	}
	content_open = false;
}

/*
* request the request_url and ask the confirm dialog if requested
*/
function requestPage(request_url, with_request_dialog, request_dialog) {
	if ((with_request_dialog == true && confirm(request_dialog)) || (with_request_dialog == false)) {
		// request page
		advAJAX.get({
			url : request_url,
			onSuccess : function(obj) {
				if (obj.responseText == "true") {
					removeObjects();
					return true;
				} else {
					alert("Fehler: "+obj.responseText);
					removeObjects();
					return false;
				}
			},
			onError : function(obj) {
				removeObjects();
				alert("Error: " + obj.status);
				return false;
			}
		});
	}
}

function changePlayerStats(request_url, with_request_dialog, request_dialog, span_id, css_classname) {
	if (requestPage(request_url, with_request_dialog, request_dialog) == false) {
		return;
	}
	try {
		document.getElementById("pr_"+span_id).setAttribute('class',"bg_"+css_classname);
	} catch(e) { /* alert("error1: "+e);  - no error message here! used at playerinformation.php without background color */ }
	try {
		document.getElementById("pn_"+span_id).setAttribute('class',css_classname);
	} catch(e) { alert("error2: "+e); }
}

function deleteFleetMovement(fleet_id,sub_fleet_id) {
	if (requestPage("ajax_fleet_movement.php?fleet_id="+fleet_id+"&sub_fleet_id="+sub_fleet_id+"&action=delete", false, false) == false) {
		return;
	}
	try {
		var html_id = "fleet_"+fleet_id+"_"+sub_fleet_id;
		document.getElementById(html_id).parentNode.removeChild(document.getElementById(html_id));
		
		// rebuild order of class attributes for each row to avoid two adjacent colors
		try {
			var i = 1; // first table row = header row
			while (row = document.getElementById("fleet_movement_table").getElementsByTagName("tr")[i]) {
				if (i%2 == 1) {
					row.setAttribute('class',"firstcolor");
				} else {
					row.setAttribute('class',"secondcolor");
				}
				
				i++;
			}
		
		} catch(ignore_me) {
			// to be ignored
		}
		
	} catch(e) { 
		alert("Error: "+e); 
	}
}

function setValueHelpContent(current_object, new_value) {
	document.getElementById(current_object).value = new_value;
	removeObjects();
}

function MousePressed() {
	// check if we have an object
	if (current_object != "") {
		var top_left_x = document.getElementById(current_object).offsetLeft;
		var top_left_y = document.getElementById(current_object).offsetTop;
		var lower_right_x = document.getElementById(current_object).offsetLeft + document.getElementById(current_object).offsetWidth;
		var lower_right_y = document.getElementById(current_object).offsetTop + document.getElementById(current_object).offsetHeight;

		// check is mouse is inside our current object that shall be moved
		if ( mouse_x > top_left_x && mouse_x < lower_right_x && mouse_y > top_left_y && mouse_y < lower_right_y ) {
			mouse_down = true;
		}
	}
}

function MouseReleased() {
	mouse_down = false;
}

function saveFormData(form_id,id,popup_id) {
	var i,j;
	var content = new Array();

	if (popup_id != null) {
		hideUnhideObject(popup_id);
	}

	try {
		var form = document.getElementById(form_id);
		if (form == null) {
			alert("Wrong ID!");
			return false;
		}
		var inputs = form.getElementsByTagName("input");

		// Input fields (Radio, Checkbox, Hidden, Buttons, Passwd and normal input)
		for (i = 0; i < inputs.length; i++) {
			if (inputs[i].hasAttribute("wairole") == true) {
				// dojo control that causes trouble on loading but is not needed
				continue;
			}
			if (inputs[i].hasAttribute("readonly") == true) {
				// dojo dropdown icons have attributes with read only which cannot be set 
				continue;
			}
			if (inputs[i].getAttribute("type") == "button") {
				// no need to save button values
				continue;
			}
			
			if (inputs[i].getAttribute("type") == "radio") {
				if (inputs[i].checked == true) {
					content.push(new Array(inputs[i].name,inputs[i].value,"checked")); // do not store ID if available!
				}
			} else if (inputs[i].getAttribute("type") == "checkbox") {
				try {
					var dijit_checked = dijit.byId(inputs[i].id).get("checked");
				} catch(no_dijit_control) {
					var dijit_checked = false;
				}
				
				if (inputs[i].checked == true || inputs[i].hasAttribute("value") && dijit_checked == true) {
					content.push(new Array(new Array(inputs[i].id,inputs[i].name),"checked"));
				} else {
					content.push(new Array(new Array(inputs[i].id,inputs[i].name),""));
				}
			} else if (inputs[i].getAttribute("type") != "submit") {
				// hard coded deviations
				if (form_id == "userman1") {
					if (inputs[i].name != "id" && inputs[i].name != "username" && inputs[i].name != "ingameusername" && inputs[i].name != "email") {
						content.push(new Array(new Array(inputs[i].id,inputs[i].name),inputs[i].value));
					}
				} else {
					content.push(new Array(new Array(inputs[i].id,inputs[i].name),inputs[i].value));
				}
			}
		}

		// Text areas
		var textareas = form.getElementsByTagName("textarea");
		for (i = 0; i < textareas.length; i++) {
			content.push(new Array(new Array(inputs[i].id,inputs[i].name),textareas[i].value));
			//alert("Name: "+textareas[i].name+" Value: "+textareas[i].value);
		}

		// Selection boxes
		var selection = form.getElementsByTagName("select");
		var options;
		for (i = 0; i < selection.length; i++) {
			// check all options - which one is checked ?
			options = selection[i].getElementsByTagName("option");
			for (j = 0; j < options.length; j++) {
				if (options[j].selected == true) {
					content.push(new Array(selection[i].name,options[j].value));
					//alert("Name: "+selection[i].name+" Value: "+options[j].value);
				}

			}
		}
		
		// dojo selection boxes
		// table has class dijitSelect
		var selection = form.getElementsByTagName("table");
		var classes;
		for (i = 0; i < selection.length; i++) {
			// check all options - which one is checked ?
			classes = selection[i].getAttribute("class");
			if (classes != null && classes.indexOf("dijitSelect") > 0) {
				content.push(new Array(new Array(selection[i].id,""),dijit.byId(selection[i].id).get("value")));
			}
		}

		content = php_serialize(content);
		// save data
		// document.getElementById("load_form").style.display = "inline";
		var result = saveData(form_id,id,content);
		if (result == true) {
			document.getElementById("load_form").style.display = "inline";
		}

	} catch(e) {
		alert("error: "+e);
	}
	return false;
}

function loadFormData(form_id,id,popup_id) {
	var obj;

	if (popup_id != null) {
		hideUnhideObject(popup_id);
	}

	// request page via GET
	advAJAX.get({
		url : "ajax_load_data.php?folder="+form_id+"&id="+id,
		onSuccess : function(obj) {
			try {
				var content = php_unserialize(obj.responseText);
			} catch(e) {
				alert(e);
				return;
			}
			
			for (var i = 0; i < content.length; ++i) {
				try {
					
					if (content[i][0] instanceof Array) {
						// new way to access data via ID or NAME (fallback)
						if (content[i][0][0] != "") {
							var tmp_obj = document.getElementById(content[i][0][0]);
						} else {
							var tmp_obj = document.getElementsByName(content[i][0][1]);
						}
					} else {
						// old stored data which is only stored with NAME
						var tmp_obj = document.getElementsByName(content[i][0]);						
					}
					
					if (tmp_obj.length == 1) {
						obj = tmp_obj[0];
					} else if (tmp_obj instanceof Array && tmp_obj.length > 1) {
						// radio buttons have the same name -> several hits
						for (k=0; k < tmp_obj.length; ++k) { // radio buttons have the same name
							obj = tmp_obj[k];

							if (obj.getAttribute("type") == "radio") {
								if (obj.value == content[i][1] && content[i][2] == "checked") {
									var checked_attr = document.createAttribute("checked");
									obj.setAttributeNode(checked_attr);
									obj.checked = true;
								} else if (obj.value == content[i][1] && content[i][2] == "") {
									obj.checked = false;
								}
							} else {
								console.log("unexpected else path");
							}
						}
						return;
					} else {
						obj = tmp_obj;
					}

					// what kind of object do we have ?
					if (obj.nodeName == "SELECT") {
						// process all options of that node
						for (var j=0; j < obj.childNodes.length; ++j) {
							if (obj.childNodes[j].value == content[i][1]) {
								var selected_attr = document.createAttribute("selected");
								obj.childNodes[j].setAttributeNode(selected_attr);
								obj.childNodes[j].selected = true;
							} else {
								obj.childNodes[j].selected = false;
							}
						}
					}else if (obj.nodeName == "TABLE") {
						// dijit dropdowns
						dijit.byId(obj.id).set("value",content[i][1]);
					} else {
						if (obj.getAttribute("type") == "radio") {
							console.log("Radiobuttons must be handled via NAME but not ID");
						} else if (obj.getAttribute("type") == "checkbox") {
							if (content[i][1] == "checked") {
								//var checked_attr = document.createAttribute("checked");
								//obj.setAttributeNode(checked_attr);
								obj.checked = true;
								try {
									dijit.byId(obj.id).set("checked",true);
								} catch (no_dijit) {}
							} else {
								obj.checked = false;
								try {
									dijit.byId(obj.id).set("checked",false);
								} catch (no_dijit) {}
							}
						} else {
							obj.value = content[i][1];
						}
					}
				} catch(e) {
					// alert("error: "+e);
					// element not found
				}
			}

		},
		onError : function(obj) { alert("Error: " + obj.status); return ""; }
	});
}

function deleteFormData(folder,id,popup_id,items_at_folder) {
	saveData(folder,id,"",popup_id);
	if (items_at_folder == 1) document.getElementById("load_form").style.display = "none"; // remove loading icon after deletion
}

function saveData(folder,id,content,popup_id) {
	if (popup_id != null) {
		hideUnhideObject(popup_id);
	}

	// request page via POST
	advAJAX.post({
		url : "ajax_save_data.php",
		parameters : {
		"folder" : folder,
		"id" : id,
		"content" : escape(content)
		},
		onSuccess : function(obj) {
			if (obj.responseText == "true") {
				return true;
			} else {
				alert("not saved: "+obj.responseText);
				return false;
			}
		},
		onError : function(obj) {
			alert("Error: " + obj.status);
			return false;
		}
	});

	return true;
}

function setSelectionToToday() {
	if(typeof(this.TimezoneOffset) == 'undefined') {
		// no offset defined yet, do not use an offset
		var TimezoneOffset = 0;
	} else {
		// use the offset as it was defined
		var TimezoneOffset = this.TimezoneOffset;
	}
  
    var localTime = new Date();
    var temp = localTime.getTime() + TimezoneOffset * 3600000;
    var current_timestamp =  new Date(temp);

	try {
		document.getElementById("year1").value  = current_timestamp.getYear();
		document.getElementById("month1").value = parseInt(current_timestamp.getMonth()+1); // January = 0 !
		document.getElementById("day1").value = parseInt(current_timestamp.getDate());
		document.getElementById("hour1").value = 0;
		document.getElementById("minute1").value = 0;
		document.getElementById("second1").value = 0;

		document.getElementById("year2").value  = current_timestamp.getYear();
		document.getElementById("month2").value = parseInt(current_timestamp.getMonth()+1); // January = 0 !
		document.getElementById("day2").value = parseInt(current_timestamp.getDate());
		document.getElementById("hour2").value = 23;
		document.getElementById("minute2").value = 59;
		document.getElementById("second2").value = 59;
		
		// uncheck never_mind_box
		var obj = document.getElementById("never_mind_box");
		obj.checked = false;
		
	} catch(e) {
		// irgnore error
	}
}

function setCurrentDateTimeValues(year,month,day,hour,minute,second) {
	if(typeof(this.TimezoneOffset) == 'undefined') {
		// no offset defined yet, do not use an offset
		var TimezoneOffset = 0;
	} else {
		// use the offset as it was defined
		var TimezoneOffset = this.TimezoneOffset;
	}
  
    var localTime = new Date();
    var temp = localTime.getTime() + TimezoneOffset * 3600000;
    var current_timestamp =  new Date(temp);
	
	if (year != "") {
		try {
			document.getElementById(year).value = current_timestamp.getYear();
		} catch(e) {
			// irgnore error
		}
	}
	if (month != "") {
		try {
			document.getElementById(month).value = parseInt(current_timestamp.getMonth()+1); // January = 0 !
		} catch(e) {
			// irgnore error
		}
	}
	if (day != "") {
		try {
			document.getElementById(day).value = parseInt(current_timestamp.getDate());
		} catch(e) {
			// irgnore error
		}
	}
	if (hour != "") {
		try {
			document.getElementById(hour).value = parseInt(current_timestamp.getHours());
		} catch(e) {
			// irgnore error
		}
	}
	if (minute != "") {
		try {
			document.getElementById(minute).value = parseInt(current_timestamp.getMinutes());
		} catch(e) {
			// irgnore error
		}
	}
	if (second != "") {
		try {
			document.getElementById(second).value = parseInt(current_timestamp.getSeconds());
		} catch(e) {
			// irgnore error
		}
	}

}