<?php

class Messages {

	private $dbcon;							// database connection object
	private $messagetable;					// database table name for messages
	private $noticetable;					// database table name for notices
	private $playertable;					// database table name for players

	function __construct($dbcon, $messagetable, $noticetable, $playertable) {
		if (!isset($dbcon) || $dbcon == null || !$dbcon) {
			return false;
		}
		$this->dbcon = $dbcon;

		if (empty($messagetable)) return false;
		$this->messagetable = $messagetable;

		if (empty($noticetable)) return false;
		$this->noticetable = $noticetable;

		if (empty($playertable)) return false;
		$this->playertable = $playertable;
	}


	public function get_message_overview($playerid=null) {
		if (!isset($_SESSION['s_userid'])) return false;

		// no outer join to filter for messages where player does not exist
		$query = "SELECT m.id, m.messagetime, m.subject, p.playername FROM $this->messagetable m, $this->playertable p WHERE m.userid=".$_SESSION['s_userid']." AND m.player_id_from = p.id";
		if ($playerid > 0) {
			$playerid = intval($playerid);
			$query .= " AND m.player_id_from = ".$playerid;
		}
		$res = mysql_query($query,$this->dbcon) or die(mysql_error($this->dbcon));

		$return_value =
		"{ identifier: 'id',\n".
		"label: 'id',\n".
		"items: [\n";
		$items = 0;
		while ($line = mysql_fetch_object($res)) {
			$return_value .= "{ id:'$line->id', playername:'$line->playername', subject:'".addslashes($line->subject)."', messagetime:'$line->messagetime' },\n";
			$items++;
		}
		if ($items > 0) {
			$return_value = substr($return_value,0,strlen($return_value)-2)."\n";
		}
		$return_value .= "]}\n";

		return $return_value;
	}

	public function get_message_count($playerid) {
		if (!isset($_SESSION['s_userid'])) return 0;
		$playerid = intval($playerid);

		// do not use count(*) here, we use the identical query as in get_message_overview() as this will be triggered if the user
		// follows the navigation to the message details and the query can be fulfilled by query buffer this way
		$query = "SELECT m.id, m.messagetime, m.subject, p.playername FROM $this->messagetable m, $this->playertable p WHERE m.userid=".$_SESSION['s_userid']." AND m.player_id_from = p.id AND m.player_id_from = ".$playerid;
		$res = mysql_query($query,$this->dbcon) or die(mysql_error($this->dbcon));

		return mysql_num_rows($res);
	}



	public function get_message_content($message_id) {
		if (!is_numeric($message_id) || $message_id < 1) return false;

		$query = "SELECT message_content FROM $this->messagetable WHERE userid=".$_SESSION['s_userid']." AND id = $message_id";
		$res = mysql_query($query,$this->dbcon) or die(mysql_error($this->dbcon));

		if (mysql_num_rows($res) != 1) {
			return "";
		}
		$line = mysql_fetch_object($res);
		$content = $line->message_content;

		$content = $this->get_bb_2_html($content);

		return $content;
	}

	public function publish_message($message_id) {
		if (!is_numeric($message_id) || $message_id < 1) return false;

		if (!defined("MESSAGES_PUBLISH_HEADER")) return false;

		// get message content
		$query = "SELECT m.*, ps.playername as sender_name, pt.playername as receipt_name
		FROM $this->messagetable m
		LEFT JOIN $this->playertable ps ON (m.player_id_from = ps.id)
		LEFT JOIN $this->playertable pt ON (m.player_id_to = pt.id)
		WHERE m.userid=".$_SESSION['s_userid']." AND m.id = $message_id";

		$res = mysql_query($query,$this->dbcon) or die(mysql_error($this->dbcon));

		if (mysql_num_rows($res) != 1) {
			return "";
		}
		$line = mysql_fetch_object($res);
		$message_content = $line->message_content;
		$playerid        = $line->player_id_from;

		// Workaround needed as notices worked with utf8-encode before inserting into DB and no update mechanism in place now
		$message_content = utf8_encode($message_content);

		$content = utf8_encode(MESSAGES_PUBLISH_HEADER);
		$content = str_replace("&sender","[b]$line->sender_name[/b]",$content);
		$content = str_replace("&recipient","[b]$line->receipt_name[/b]",$content);
		$content = str_replace("&date","[b]$line->messagetime[/b]",$content);
		$content = str_replace("&message",$message_content."\n\n",$content);

		// get notice ID
		$query = "SELECT id FROM $this->noticetable WHERE player_id = ".$playerid;
		$res = mysql_query($query,$this->dbcon) or die(mysql_error($this->dbcon));

		if (mysql_num_rows($res) == 0) {
			// insert
			$query = "INSERT INTO $this->noticetable (player_id, noticetext, last_update) VALUES ($playerid, '".mysql_real_escape_string($content)."', NOW())";
		} else {
			// update
			$line = mysql_fetch_object($res);
			$id  = $line->id;

			$query = "UPDATE $this->noticetable SET noticetext = CONCAT('".mysql_real_escape_string($content)."', noticetext), last_update = NOW() WHERE id=$id";
		}

		$res = mysql_query($query,$this->dbcon) or die(mysql_error($this->dbcon));

		return true;
	}

	public function delete_message($message_id) {
		if (!is_numeric($message_id) || $message_id < 1) return false;

		// delete message content
		$query = "DELETE FROM $this->messagetable WHERE userid=".$_SESSION['s_userid']." AND id = $message_id LIMIT 1";
		$res = mysql_query($query,$this->dbcon) or die(mysql_error($this->dbcon));

		if (mysql_affected_rows($this->dbcon) == 0) {
			return "0 entries deleted";
		} else {
			return true;
		}

	}

	public static function get_bb_2_html($content) {
		$content = str_replace("\n","<br>\n",$content);

		$content = str_replace("[p]","<p>",$content);
		$content = str_replace("[/p]","</p>",$content);
		$content = str_replace("[b]","<b>",$content);
		$content = str_replace("[/b]","</b>",$content);
		$content = str_replace("[u]","<u>",$content);
		$content = str_replace("[/u]","</u>",$content);
		$content = str_replace("[s]","<s>",$content);
		$content = str_replace("[/s]","</s>",$content);
		$content = str_replace("[i]","<i>",$content);
		$content = str_replace("[/i]","</i>",$content);

		$content = str_replace("[sub]","<sub>",$content);
		$content = str_replace("[/sub]","</sub>",$content);
		$content = str_replace("[sup]","<sup>",$content);
		$content = str_replace("[/sup]","</sup>",$content);


		$content = str_replace("[*]","</li><li>",$content);
		$content = str_replace("[list]</li>","<ul>",$content);
		$content = str_replace("[/list]","</li></ul>",$content);

		$content = preg_replace("#\[color\=(\#[0-9A-F]{0,6}|[A-z]+)\](.*)\[\/color\]#Ui", "<span style=\"color: $1;\">$2</span>", $content);
		$content = preg_replace("#\[size\=([0-9A-F]{0,2})\](.*)\[\/size\]#Ui", "<span style=\"font-size: $1;\">$2</span>", $content);
		$content = preg_replace("#\[font\=(.*)\](.*)\[\/font\]#Ui", "<span style=\"font-family: $1;\">$2</span>", $content);

		$content = preg_replace("#\[url\](http\:\/\/.+)\[\/url\]#i", "<a class=\"link\" href=\"$1\">$1</a>", $content);
		$content = preg_replace("#\[url\=(http\:\/\/.+)\](.*)\[\/url\]#i", "<a class=\"link\" href=\"$1\">$2</a>", $content);

		$content = preg_replace("#\[email\](mailto\:.+)\[\/email\]#i", "<a class=\"link\" href=\"$1\">$1</a>", $content);
		$content = preg_replace("#\[email\=(mailto\:.+)\](.*)\[\/email\]#i", "<a class=\"link\" href=\"$1\">$2</a>", $content);

		$content = preg_replace("#\[center\](.*)\[\/center\]#Ui", "<div style=\"text-align: center;\">$1</div>", $content);
		$content = preg_replace("#\[align\=(.*)\](.*)\[\/align\]#Ui", "<div style=\"text-align: $1;\">$2</div>", $content);

		$content = preg_replace("#\[player\=(.*)\](.*)\[\/player\]#Ui", "<a class=\"link\" href=\"playerinformation.php?ogame_id=$1\">$2</a>", $content);

		return $content;
	}

}
?>