<?php

class Stats {

	private $dbcon       = null;
	private $utablename  = null;
	private $playertable = null;
	private $allytable = null;

	const ascending  = "ASC";
	const descending = "DESC";

	public function __construct( $dbcon, $utablename, $playertable, $allytable ) {
		if ($dbcon == null) return false;
		$this->dbcon = $dbcon;

		if ($utablename == "") return false;
		$this->utablename = $utablename;

		if ($playertable == "") return false;
		$this->playertable = $playertable;

		if ($allytable == "") return false;
		$this->allytable = $allytable;

		return true;
	}

	public function getPlayerStatsUI($military, $OGame_3_0) {
		if (!defined("STATS_PLAYERSTATUS")) return false;

		$suffix = ($military === false) ? "1" : "2";

		$content = '
		<div>'.STATS_PLAYERSTATUS.'<span style="margin-left: 25px;" class="inactive">'.STATS_INACTIVE.':</span>
		<select name="select_inactive" dojoType="dijit.form.Select" id="select_inactive'.$suffix.'" jsId="select_inactive'.$suffix.'">
		<option value="-">-</option>\n";
		<option value="yes">'.STATS_YES.'</option>\n";
		<option value="inactive">'.STATS_INACTIVE.'</option>\n";
		<option value="long_inactive">'.STATS_LONG_INACTIVE.'</option>\n";
		<option value="no">'.STATS_NO.'</option>\n";
		</select>
		<span style="margin-left: 25px;" class="vacation">'.STATS_VACATION.':</span>
		<select name="select_vacation" dojoType="dijit.form.Select" id="select_vacation'.$suffix.'" jsId="select_vacation'.$suffix.'">
		<option value="-">-</option>\n";
		<option value="yes">'.STATS_YES.'</option>\n";
		<option value="no">'.STATS_NO.'</option>\n";
		</select>
		<span class="noob">'.STATS_NOOB.':</span>
		<select name="select_noob" dojoType="dijit.form.Select" id="select_noob'.$suffix.'" jsId="select_noob'.$suffix.'">
		<option value="-">-</option>\n";
		<option value="yes">'.STATS_YES.'</option>\n";
		<option value="no">'.STATS_NO.'</option>\n";
		</select>
		<button dojoType="dijit.form.Button" type="button" onClick="galaxytool_load_new_stats(\'playerstats\', '.$suffix.', playergrid'.$suffix.', playerstore'.$suffix.')">'.STATS_SEARCH.'</button>
		</div>
		<div style="margin-top: 10px; width:100%;">';

		if (($_SESSION['s_diplomatic']) ||  $_SESSION['s_candelete']) {
			$content .= '
        	<div dojoType="dijit.form.DropDownButton" disabled="true" id="playerstatus_button'.$suffix.'" jsId="playerstatus_button'.$suffix.'">
            <span>'.STATS_CHANGE_PLAYER_STATUS.'</span>
        	<div dojoType="dijit.Menu">
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'nothing\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_NOTHING.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'nap\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_NAP.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'ally\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_ALLIED.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'war\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_WAR.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'boycott\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_BOYCOTT.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'neutral\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_NEUTRAL.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'own\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_OWN.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_playerstatus(\'wing\', playergrid'.$suffix.', playerstore'.$suffix.')">
                '.STATS_WING.'
            </div>
            </div>
            </div>
            ';
			if ($_SESSION['s_candelete']) {
				$content .= '
        	<button dojoType="dijit.form.Button" type="button" id="delete_player_button'.$suffix.'" disabled="true"
                    iconClass="trashicon" showLabel="false" onClick="galaxytool_delete_player(playergrid'.$suffix.', playerstore'.$suffix.')">'.STATS_DELETE.'</button>
			';
			}
		} // diplomatic permissions or can_delete permissions

		$store_url = ($military === false) ? "ajax/ajax_stats.php?type=playerstats&military=false" : "ajax/ajax_stats.php?type=playerstats&military=true";
		$content .= '
        </div>

        <div dojoType="dojox.data.QueryReadStore" jsId="playerstore'.$suffix.'" id="playerstore'.$suffix.'" url="'.$store_url.'"></div>
        <table style="width:100%;" dojoType="dojox.grid.EnhancedGrid" id="playergrid'.$suffix.'" jsId="playergrid'.$suffix.'" store="playerstore'.$suffix.'"
                    plugins="plugins" rowsPerPage="'.$_SESSION['s_search_results'].'"
               autoHeight="100" rowCount="'.$_SESSION['s_search_results'].'"
               rowSelector="20px" delayScroll="true">
			<thead>
				<tr>';

		if ($military === false) {
			// standard stats
			if ($OGame_3_0 === true) {
				$content .= '
				<th width="30px" field="rank" formatter="galaxytool_pstats_rank'.$suffix.'">'.STATS_RANK.'</th>
				<th width="110px" field="name" formatter="galaxytool_pstats_name'.$suffix.'">'.STATS_PLAYERNAME.'</th>
				<th width="30px" field="status" formatter="galaxytool_pstats_status">'.STATS_STATUS.'</th>
				<th width="100px" field="allyname" formatter="galaxytool_pstats_ally'.$suffix.'">'.STATS_ALLYNAME.'</th>
				<th width="90px" field="score" formatter="galaxytool_stats_score">'.STATS_SCORE.'</th>
				<th width="90px" field="economy" formatter="galaxytool_pstats_economy'.$suffix.'">'.STATS_ECONOMY.' ('.STATS_RANK.')</th>
				<th width="90px" field="fleet" formatter="galaxytool_pstats_fleet'.$suffix.'">'.STATS_FLEET.' ('.STATS_RANK.')</th>
				<th width="auto" field="research" formatter="galaxytool_pstats_research'.$suffix.'">'.STATS_RESEARCH.' ('.STATS_RANK.')</th>
				';
			} else {
				$content .= '
				<th width="50px" field="rank" formatter="galaxytool_pstats_rank'.$suffix.'">'.STATS_RANK.'</th>
				<th width="140px" field="name" formatter="galaxytool_pstats_name'.$suffix.'">'.STATS_PLAYERNAME.'</th>
				<th width="50px" field="status" formatter="galaxytool_pstats_status">'.STATS_STATUS.'</th>
				<th width="120px" field="allyname" formatter="galaxytool_pstats_ally'.$suffix.'">'.STATS_ALLYNAME.'</th>
				<th width="90px" field="score" formatter="galaxytool_stats_score">'.STATS_SCORE.'</th>
				<th width="100px" field="fleet" formatter="galaxytool_pstats_fleet'.$suffix.'">'.STATS_FLEET.' ('.STATS_RANK.')</th>
				<th width="auto" field="research" formatter="galaxytool_pstats_research'.$suffix.'">'.STATS_RESEARCH.' ('.STATS_RANK.')</th>
				';
			}

		} else {
			// military stats
			$content .= '
			<th width="30px" field="hrank" formatter="galaxytool_pstats_rank'.$suffix.'">'.STATS_RANK.'</th>
			<th width="110px" field="name" formatter="galaxytool_pstats_name'.$suffix.'">'.STATS_PLAYERNAME.'</th>
			<th width="30px" field="status" formatter="galaxytool_pstats_status">'.STATS_STATUS.'</th>
			<th width="100px" field="allyname" formatter="galaxytool_pstats_ally'.$suffix.'">'.STATS_ALLYNAME.'</th>
			<th width="90px" field="fb" formatter="galaxytool_stats_score">'.STATS_MILITARY_BUILD.'</th>
			<th width="90px" field="fd" formatter="galaxytool_pstats_md'.$suffix.'">'.STATS_MILITARY_DESTROYED.' ('.STATS_RANK.')</th>
			<th width="90px" field="fl" formatter="galaxytool_pstats_ml'.$suffix.'">'.STATS_MILITARY_LOST.' ('.STATS_RANK.')</th>
			<th width="auto" field="honour" formatter="galaxytool_stats_honour'.$suffix.'">'.STATS_HONOUR.' ('.STATS_RANK.')</th>
			';
		}

		$content .= '
				</tr>
			</thead>
        </table>
        <div style="width:90%; text-align:center; margin-top:10px;">
    	<span class="bg_nothing">&nbsp;&nbsp;</span> '.STATS_NOTHING.'
    	<span class="bg_neutral" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_NEUTRAL.'
    	<span class="bg_boycott" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_BOYCOTT.'
    	<span class="bg_nap" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_NAP.'
    	<span class="bg_ally" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_ALLIED.'
    	<span class="bg_war" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_WAR.'
    	<span class="bg_own" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_OWN.'
    	<span class="bg_wing" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_WING.'
    	</div>
        ';

		return $content;
	}

	public function getPlayerStats($start, $count, $sort, $sortorder, $inactive, $vacation, $noob) {
		$start = intval($start);
		$count = intval($count);

		if (!defined("PLAYER_BANNED")) return false;
		if ($start < 0) return false;
		if ($count < 0) return false;
		if ($inactive != "i" && $inactive != "I" && $inactive != "true" && $inactive != "false" && $inactive != null) return false;
		if ($vacation != "true" && $vacation != "false" && $vacation != null) return false;
		if ($noob != "true" && $noob != "false" && $noob != null) return false;

		switch ($sort) {
			case "rank": $sort = "rank"; break;
			case "hrank": $sort = "hrank"; break;
			case "name": $sort = "playername"; break;
			case "status": $sort = "rank"; break; // no sort by status string possible
			case "allyname": $sort = "allyname"; break;
			case "score": $sort = "points"; break;
			case "fleet": $sort = "fpoints"; break;
			case "research": $sort = "rpoints"; break;
			case "economy": $sort = "epoints"; break;
			case "honour": $sort = "hpoints"; break;
			case "fb": $sort = "fbpoints"; break;
			case "fd": $sort = "fdpoints"; break;
			case "fl": $sort = "flpoints"; break;

			default: return false;
		}

		if ($sortorder != Stats::ascending AND $sortorder != Stats::descending) return false;

		$where_selection = ""; // starts with AND
		if ($inactive != null) {
			if ($inactive == "true") {
				$where_selection .= " AND inactive='true'"; // returns also long inactive players
			} elseif ($inactive == "i") {
				$where_selection .= " AND inactive='true' AND long_inactive='false'"; // only i
			} elseif ($inactive == "I") {
				$where_selection .= " AND long_inactive='true'";
			} elseif ($inactive == "false") {
				$where_selection .= " AND inactive='false'"; // covers also long_inactive = false
			}
		}
		if ($vacation != null) {
			$where_selection .= " AND vacation='".mysql_real_escape_string($vacation)."'";
		}
		if ($noob != null) {
			$where_selection .= " AND noob='".mysql_real_escape_string($noob)."'";
		}

		// determine number of rows
		$query = "SELECT count(*)as counter FROM $this->playertable WHERE rank > 0 $where_selection";
		$res = mysql_query($query, $this->dbcon) or die($query."\n".mysql_error());
		$line = mysql_fetch_object($res);
		$counter = $line->counter;

		$query = "SELECT u.username, p.*,DATE_FORMAT(CONVERT_TZ(p.last_stats_update, '+00:00',".
		" '".$_SESSION['s_timezone_offset']."'), '%d. %m. %Y - %H:%i:%s') as last_stats_update, ".
		" a.allyname, a.diplomatic_status as dipl_status".
		" FROM $this->playertable p".
		" LEFT JOIN $this->allytable a ON (p.alliance_id = a.id)".
		" LEFT JOIN $this->utablename u ON (p.user_id = u.id)".
		" WHERE p.rank > 0 AND p.banned='false' $where_selection ORDER BY $sort $sortorder LIMIT $start,$count";
		$res = mysql_query($query, $this->dbcon) or die($query."\n".mysql_error());

		$return_value =
		"{ identifier: 'id',\n".
		"label: 'id',\n".
		"numRows: $counter,\n".
		"items: [\n";

		$first_item = true;
		while ($line = mysql_fetch_object($res)) {
			if ($first_item) $first_item = false;
			else $return_value .= ",";

			$status = ($line->banned == "true") ? PLAYER_BANNED : "";
			$status .= ($line->vacation == "true") ? PLAYER_VACATION_MODE : "";
			$status .= ($line->noob == "true") ? PLAYER_NOOB : "";
			$status .= ($line->inactive == "true") ? PLAYER_INACTIVE : "";
			$status .= ($line->long_inactive == "true") ? PLAYER_LONG_INACTIVE : "";

			$return_value .= "{ id:'$line->id',".
			" rank:'$line->rank',".
			" erank:'$line->erank',".
			" rrank:'$line->rrank',".
			" frank:'$line->frank',".
			" hrank:'$line->hrank',".
			" fbrank:'$line->fbrank',".
			" fdrank:'$line->fdrank',".
			" flrank:'$line->flrank',".
			" name:'$line->playername',".
			" status:'$status',".
			" allyname:'$line->allyname',".
			" a_id:'$line->alliance_id',".
			" score:'$line->points',".
			" economy:'$line->epoints',".
			" fleet:'$line->fpoints',".
			" research:'$line->rpoints',".
			" honour:'$line->hpoints',".
			" fb:'$line->fbpoints',".
			" fd:'$line->fdpoints',".
			" fl:'$line->flpoints',".
			" last_update:'$line->last_stats_update',".
			" username:'$line->username',".
			" p_status:'$line->diplomatic_status',".
			" a_status:'$line->dipl_status'".
			" }\n";
		}


		$return_value .= "]}\n";


		return $return_value;
	}


	public function getAllyStatsUI($military, $OGame_3_0) {
		$content = "";
		$content .= '<div style="margin-top: 10px;">';
		$suffix = ($military === false) ? "1" : "2";

		if (($_SESSION['s_diplomatic']) ||  $_SESSION['s_candelete']) {
			$content .= '
			<div style="margin-top: 10px;">
        	<div dojoType="dijit.form.DropDownButton" disabled="true" id="allystatus_button'.$suffix.'" jsId="allystatus_button'.$suffix.'">
            <span>'.STATS_CHANGE_ALLIANCE_STATUS.'</span>
        	<div dojoType="dijit.Menu">
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'nothing\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_NOTHING.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'nap\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_NAP.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'ally\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_ALLIED.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'war\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_WAR.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'boycott\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_BOYCOTT.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'neutral\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_NEUTRAL.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'own\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_OWN.'
            </div>
            <div dojoType="dijit.MenuItem" onClick="galaxytool_allystatus(\'wing\', allygrid'.$suffix.', allystore'.$suffix.')">
                '.STATS_WING.'
            </div>
            </div>
            </div>
            ';
			if ($_SESSION['s_candelete']) {
				$content .= '
	        	<button dojoType="dijit.form.Button" type="button" id="delete_ally_button'.$suffix.'" disabled="true"
	                    iconClass="trashicon" showLabel="false" onClick="galaxytool_delete_ally(allygrid'.$suffix.', allystore'.$suffix.')">'.STATS_DELETE.'</button>
				';
			}
		}
		$content .= '
	        ';

		$store_url = ($military === false) ? "ajax/ajax_stats.php?type=allystats&military=false" : "ajax/ajax_stats.php?type=allystats&military=true";
		$content .= '
	    <div id="AllyDetailsDialog'.$suffix.'" dojoType="dijit.Dialog" title="'.STATS_SHOW_GRAPH.'">
	        <div dojoType="dijit.layout.ContentPane" title="" style="width: 200px; height: 400px;">
	            ...
	        </div>
	    </div>
	    <button dojoType="dijit.form.Button" type="button" id="details_button'.$suffix.'" disabled="true"
	            iconClass="magnifiericon" showLabel="false" onClick="galaxytool_ally_info('.$suffix.', allygrid'.$suffix.', allystore'.$suffix.')">'.STATS_SHOW_GRAPH.'</button>
	    </div>
        <div dojoType="dojox.data.QueryReadStore" jsId="allystore'.$suffix.'" id="allystore'.$suffix.'" url="'.$store_url.'"></div>
        <table style="width:100%;" dojoType="dojox.grid.EnhancedGrid" id="allygrid'.$suffix.'" jsId="allygrid'.$suffix.'" store="allystore'.$suffix.'"
                    plugins="plugins" rowsPerPage="'.$_SESSION['s_search_results'].'"
               autoHeight="100" rowCount="'.$_SESSION['s_search_results'].'"
               rowSelector="20px" delayScroll="true">
			<thead>
				<tr>';

			if ($military === false) {
			// standard stats
			if ($OGame_3_0 === true) {
				$content .= '
				<th width="50px" field="rank" formatter="galaxytool_astats_rank'.$suffix.'">'.STATS_RANK.'</th>
				<th width="100px" field="allyname" formatter="galaxytool_astats_name'.$suffix.'">'.STATS_ALLYNAME.'</th>
				<th width="80px" field="member" formatter="galaxytool_stats_score">'.STATS_MEMBERS.'</th>
				<th width="90px" field="score" formatter="galaxytool_stats_score">'.STATS_SCORE.'</th>
				<th width="90px" field="economy" formatter="galaxytool_pstats_economy'.$suffix.'">'.STATS_ECONOMY.' ('.STATS_RANK.')</th>
				<th width="90px" field="fleet" formatter="galaxytool_pstats_fleet'.$suffix.'">'.STATS_FLEET.' ('.STATS_RANK.')</th>
				<th width="auto" field="research" formatter="galaxytool_pstats_research'.$suffix.'">'.STATS_RESEARCH.' ('.STATS_RANK.')</th>
				';
			} else {
				$content .= '
				<th width="50px" field="rank" formatter="galaxytool_astats_rank'.$suffix.'">'.STATS_RANK.'</th>
				<th width="150px" field="allyname" formatter="galaxytool_astats_name'.$suffix.'">'.STATS_ALLYNAME.'</th>
				<th width="90px" field="member" formatter="galaxytool_stats_score">'.STATS_MEMBERS.'</th>
				<th width="90px" field="score" formatter="galaxytool_stats_score">'.STATS_SCORE.'</th>
				<th width="90px" field="fleet" formatter="galaxytool_astats_fleet'.$suffix.'">'.STATS_FLEET.' ('.STATS_RANK.')</th>
				<th width="auto" field="research" formatter="galaxytool_astats_research'.$suffix.'">'.STATS_RESEARCH.' ('.STATS_RANK.')</th>
				';
			}

		} else {
			// military stats
			$content .= '
			<th width="50px" field="rank" formatter="galaxytool_astats_rank'.$suffix.'">'.STATS_RANK.'</th>
			<th width="150px" field="allyname" formatter="galaxytool_astats_name'.$suffix.'">'.STATS_ALLYNAME.'</th>
			<th width="80px" field="member" formatter="galaxytool_stats_score">'.STATS_MEMBERS.'</th>
			<th width="90px" field="fb" formatter="galaxytool_stats_score">'.STATS_MILITARY_BUILD.'</th>
			<th width="90px" field="fd" formatter="galaxytool_astats_md'.$suffix.'">'.STATS_MILITARY_DESTROYED.' ('.STATS_RANK.')</th>
			<th width="90px" field="fl" formatter="galaxytool_astats_ml'.$suffix.'">'.STATS_MILITARY_LOST.' ('.STATS_RANK.')</th>
			<th width="auto" field="honour" formatter="galaxytool_astats_honour'.$suffix.'">'.STATS_HONOUR.' ('.STATS_RANK.')</th>
			';
		}


		$content .= '
				</tr>
			</thead>
        </table>
        <div style="width:90%; text-align:center; margin-top:10px;">
    	<span class="bg_nothing">&nbsp;&nbsp;</span> '.STATS_NOTHING.'
    	<span class="bg_neutral" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_NEUTRAL.'
    	<span class="bg_boycott" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_BOYCOTT.'
    	<span class="bg_nap" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_NAP.'
    	<span class="bg_ally" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_ALLIED.'
    	<span class="bg_war" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_WAR.'
    	<span class="bg_own" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_OWN.'
    	<span class="bg_wing" style="margin-left:20px;">&nbsp;&nbsp;</span> '.STATS_WING.'
    	</div>
        ';

		return $content;
	}

	public function getAllyStats($start, $count, $sort, $sortorder) {

		$start = intval($start);
		$count = intval($count);

		if (!defined("PLAYER_BANNED")) return false;// no language file loaded
		if ($start < 0) return false;
		if ($count < 0) return false;

		switch ($sort) {
			case "rank": $sort = "rank"; break;
			case "hrank": $sort = "hrank"; break;
			case "member": $sort = "members"; break;
			case "allyname": $sort = "allyname"; break;
			case "score": $sort = "points"; break;
			case "fleet": $sort = "fpoints"; break;
			case "research": $sort = "rpoints"; break;
			case "economy": $sort = "epoints"; break;
			case "honour": $sort = "hpoints"; break;
			case "fb": $sort = "fbpoints"; break;
			case "fd": $sort = "fdpoints"; break;
			case "fl": $sort = "flpoints"; break;

			default: return false;
		}

		if ($sortorder != Stats::ascending AND $sortorder != Stats::descending) return false;

		// determine number of rows
		$query = "SELECT count(*)as counter FROM $this->allytable WHERE rank > 0";
		$res = mysql_query($query, $this->dbcon) or die($query."\n".mysql_error());
		$line = mysql_fetch_object($res);
		$counter = $line->counter;

		$query = "SELECT a.*, DATE_FORMAT(CONVERT_TZ(last_update, '+00:00', '".$_SESSION['s_timezone_offset']."') , '%d. %m. %Y - %H:%i:%s') as last_update, ".
		" u.username ".
		" FROM $this->allytable a".
		" LEFT JOIN $this->utablename u ON (a.user_id = u.id)".
		" WHERE a.rank > 0 ORDER BY $sort $sortorder LIMIT $start,$count";
		$res = mysql_query($query, $this->dbcon) or die($query."\n".mysql_error());

		$return_value =
		"{ identifier: 'id',\n".
		"label: 'id',\n".
		"numRows: $counter,\n".
		"items: [\n";

		$first_item = true;
		while ($line = mysql_fetch_object($res)) {
			if ($first_item) $first_item = false;
			else $return_value .= ",";

			$return_value .= "{ id:'$line->id',".
			" rank:'$line->rank',".
			" erank:'$line->erank',".
			" rrank:'$line->rrank',".
			" frank:'$line->frank',".
			" hrank:'$line->hrank',".
			" fbrank:'$line->fbrank',".
			" fdrank:'$line->fdrank',".
			" flrank:'$line->flrank',".
			" member:'$line->members',".
			" allyname:'$line->allyname',".
			" score:'$line->points',".
			" economy:'$line->epoints',".
			" fleet:'$line->fpoints',".
			" research:'$line->rpoints',".
			" honour:'$line->hpoints',".
			" fb:'$line->fbpoints',".
			" fd:'$line->fdpoints',".
			" fl:'$line->flpoints',".
			" last_update:'$line->last_update',".
			" username:'$line->username',".
			" a_status:'$line->diplomatic_status'".
			" }\n";
		}


		$return_value .= "]}\n";


		return $return_value;

	}

	public function getAllyGraph($alliance_id, $OGame_3_0) {
		$alliance_id = intval($alliance_id);

		if (!defined("PLAYER_BANNED")) return false;// no language file loaded
		if ($alliance_id < 1) return false;

		$content = "";

		$query = "SELECT points,epoints,fpoints,rpoints FROM $this->allytable WHERE id='$alliance_id'";
		$res = mysql_query($query) or die(mysql_error());
		$line = mysql_fetch_object($res);
		$ally_points  = $line->points;
		$ally_epoints = $line->epoints;
		$ally_fpoints = $line->fpoints;
		$ally_rpoints = $line->rpoints;

		$query = "SELECT playername, points, epoints, fpoints, rpoints ".
		" FROM $this->playertable ".
		" WHERE alliance_id='$alliance_id' ".
		" ORDER BY points DESC LIMIT 10";
		$res = mysql_query($query) or die(mysql_error());
		$points  = array();
		$legend  = array();
		$epoints = array();
		$elegend = array();
		$fpoints = array();
		$flegend = array();
		$rpoints = array();
		$rlegend = array();

		while ($line = mysql_fetch_object($res)) {
			if ($line->points > 0) {
				array_push($legend,urlencode($line->playername));
				array_push($points,$line->points);
				$ally_points -= $line->points;
			}
			if ($line->epoints > 0) {
				array_push($elegend,urlencode($line->playername));
				array_push($epoints,$line->epoints);
				$ally_epoints -= $line->epoints;
			}
			if ($line->fpoints > 0) {
				array_push($flegend,urlencode($line->playername));
				array_push($fpoints,$line->fpoints);
				$ally_fpoints -= $line->fpoints;
			}
			if ($line->rpoints > 0) {
				array_push($rlegend,urlencode($line->playername));
				array_push($rpoints,$line->rpoints);
				$ally_rpoints -= $line->rpoints;
			}
		}

		// Score Pie
		if ($ally_points > 0) {
			array_push($legend,STATS_UNKNOWN);
			array_push($points,$ally_points); // add the rest of all points
		}

		if ($ally_epoints > 0) {
			array_push($elegend,STATS_UNKNOWN);
			array_push($epoints,$ally_epoints); // add the rest of all points
		}

		if ($ally_fpoints > 0) {
			array_push($flegend,STATS_UNKNOWN);
			array_push($fpoints,$ally_fpoints); // add the rest of all points
		}

		if ($ally_rpoints > 0) {
			array_push($rlegend,STATS_UNKNOWN);
			array_push($rpoints,$ally_rpoints); // add the rest of all points
		}

		/* Google API for pie charts */
		$picture_url = 'http://chart.apis.google.com/chart'.
		'?chs=300x225'. // width + height
		'&cht=p3'.
		'&chco=FF0000,00FF00|00CC00,0000FF|000066,FF00FF'. // color
		'&chma=70,70'.
		'&chts=000000,13.5'.
		'&chxs=0,000000'.
		'&chxt=x';

		if (count($points) > 0) {
			$points_url = $picture_url .
			'&chtt='.urlencode(STATS_SCORE).
			'&chds=0,'.max($points). //range
			'&chd=t:'.implode(",",$points). // data
			'&chl='.implode("|",$legend); // legend separated by |
			$content .= '<div><img src="'.$points_url.'" width="300" height="225" border="0" /></div>';
		}
		if ($OGame_3_0 === true) {
			if (count($epoints) > 0) {
				$epoints_url = $picture_url .
				'&chtt='.urlencode(STATS_ECONOMY).
				'&chds=0,'.max($epoints). //range
				'&chd=t:'.implode(",",$epoints). // data
				'&chl='.implode("|",$elegend); // legend separated by |
				$content .= '<div><img src="'.$epoints_url.'" width="300" height="225" border="0" /></div>';
			}
			if (count($fpoints) > 0) {
				$fpoints_url = $picture_url .
				'&chtt='.urlencode(STATS_MILITARY).
				'&chds=0,'.max($fpoints). //range
				'&chd=t:'.implode(",",$fpoints). // data
				'&chl='.implode("|",$flegend); // legend separated by |
				$content .= '<div><img src="'.$fpoints_url.'" width="300" height="225" border="0" /></div>';
			}
		} else {
			if (count($fpoints) > 0) {
				$fpoints_url = $picture_url .
				'&chtt='.urlencode(STATS_FLEET).
				'&chds=0,'.max($fpoints). //range
				'&chd=t:'.implode(",",$fpoints). // data
				'&chl='.implode("|",$flegend); // legend separated by |
				$content .= '<div><img src="'.$fpoints_url.'" width="300" height="225" border="0" /></div>';
			}
		}
		if (count($rpoints) > 0) {
			$rpoints_url = $picture_url .
			'&chtt='.urlencode(STATS_RESEARCH).
			'&chds=0,'.max($rpoints). //range
			'&chd=t:'.implode(",",$rpoints). // data
			'&chl='.implode("|",$rlegend); // legend separated by |
			$content .= '<div><img src="'.$rpoints_url.'" width="300" height="225" border="0" /></div>';
		}

		/* End Google API preparation */
		return $content;
	}

	public function change_player($player_id, $new_status) {
		$player_id = intval($player_id);
		if ($player_id < 1) return "";

		switch ($new_status) {
			case "neutral": $status = "neutral"; break;
			case "boycott": $status = "boycott"; break;
			case "nap":     $status = "nap";     break;
			case "ally":    $status = "ally";    break;
			case "war":     $status = "war";     break;
			case "own":     $status = "own";     break;
			case "wing":    $status = "wing";    break;
			case "nothing": $status = "nothing"; break;
			default: return "wrong status";
		}
		$query = "UPDATE $this->playertable SET diplomatic_status='$status' WHERE id='$player_id'";
		$res = mysql_query($query);
		if (!$res) {
			return "DB Query error. ".mysql_error();
		}
		return "true";

	}

	public function change_alliance($alliance_id, $new_status) {
		$alliance_id = intval($alliance_id);
		if ($alliance_id < 1) return "";

		switch ($new_status) {
			case "neutral": $status = "neutral"; break;
			case "boycott": $status = "boycott"; break;
			case "nap":     $status = "nap";     break;
			case "ally":    $status = "ally";    break;
			case "war":     $status = "war";     break;
			case "own":     $status = "own";     break;
			case "wing":    $status = "wing";    break;
			case "nothing": $status = "nothing"; break;
			default: return "wrong status";
		}

		$query = "UPDATE $this->allytable SET diplomatic_status='$status' WHERE id='$alliance_id'";
		$res = mysql_query($query);
		if (!$res) {
			return "DB Query error. ".mysql_error();
		} else {
			$query = "UPDATE $this->playertable SET diplomatic_status='$status' WHERE alliance_id='$alliance_id'";
			$res = mysql_query($query);
			if (!$res) {
				return "DB Query error. ".mysql_error();
			}
		}

		return "true";
	}

	public function alliance_delete($alliance_id) {
		$alliance_id = intval($alliance_id);
		if ($alliance_id < 1) return "";

		$query = "UPDATE $this->allytable SET rank=0, points=0, frank=0, fpoints=0, rrank=0, rpoints=0, members=0, last_update=NOW(),diplomatic_status='nothing' WHERE id='$alliance_id'";
		$res = mysql_query($query);
		if (!$res) {
			return "DB Query error. ".mysql_error();
		}
		return "true";
	}

	public static function player_delete($player_id, $mysql_con, $playertable, $playerhistory, $noticetable, $dbtablename, $combatparty, $combattable, $player_activity, $messagetable) {
		$player_id= intval($player_id);
		if ($player_id < 1) return "";

		$query = "DELETE FROM $playertable WHERE id='$player_id'";
		$res = mysql_query($query, $mysql_con) or die(mysql_error());

		// delete referenced information
		$query = "DELETE FROM $playerhistory WHERE player_id='$player_id'";
		mysql_query($query, $mysql_con) or die(mysql_error());
		$query = "DELETE FROM $noticetable WHERE player_id='$player_id'";
		mysql_query($query, $mysql_con) or die(mysql_error());
		$query = "UPDATE $dbtablename SET player_id = 0, moon = 'false', planetname = '', moonsize = 0 WHERE player_id='$player_id'";
		mysql_query($query, $mysql_con) or die(mysql_error());

		$query = "SELECT combat_id FROM $combatparty WHERE player_id='$player_id'";
		$res = mysql_query($query, $mysql_con) or die(mysql_error());
		$combat_ids = array();
		while ($line = mysql_fetch_object($res)) {
			array_push($combat_ids,$line->combat_id);
		}
		if (count($combat_ids) > 0) {
			$query = "DELETE FROM $combattable WHERE id IN (".implode(",",$combat_ids).")";
			$res = mysql_query($query, $mysql_con) or die(mysql_error());
			$query = "DELETE FROM $combatparty WHERE combat_id IN (".implode(",",$combat_ids).")";
			$res = mysql_query($query, $mysql_con) or die(mysql_error());
		}

		$query = "DELETE FROM $player_activity WHERE player_id='$player_id'";
		$res = mysql_query($query, $mysql_con) or die(mysql_error());
		$query = "DELETE FROM $messagetable WHERE player_id_from='$player_id' OR player_id_to='$player_id'";
		$res = mysql_query($query, $mysql_con) or die(mysql_error());

		return "true";
	}

}
?>