/*
* This file is used to define javascript methods which are needed for the "Activities" feature
* to show bar charts for player activities.
*
*/
var global_opening_calendar = false;
var calendar_from_time = null;
var calendar_to_time = null;

function closeCalendar() {
	try {
		if (global_opening_calendar == false && (dojo.byId("calendar_from").style.visibility=='visible' || dojo.byId("calendar_to").style.visibility=='visible')) {
			if (dojo.byId("calendar_from").style.visibility =='visible') {
				var calendar_object = "calendar_from";
			} else {
				var calendar_object = "calendar_to";
			}


			// check if mouse_x and mouse_y are still bound, otherwise close opened object
			if (calendar_object != "") {
				var top_left_x = document.getElementById(calendar_object).offsetLeft;
				var top_left_y = document.getElementById(calendar_object).offsetTop;
				var lower_right_x = document.getElementById(calendar_object).offsetLeft + document.getElementById(calendar_object).offsetWidth;
				var lower_right_y = document.getElementById(calendar_object).offsetTop + document.getElementById(calendar_object).offsetHeight;

				// check for - 5 from the left and top to the end of the element
				if ( mouse_x < top_left_x - 5 || mouse_x > lower_right_x + 5 ||
				mouse_y < top_left_y - 5 || mouse_y > lower_right_y + 5 ) {
					dojo.byId(calendar_object).style.visibility ='hidden';
				}
			}
		}
	} catch(non_existing_ids) {
		// no error
	}
	global_opening_calendar = false;
}

function handle_day_change(changed) {
	try {
		switch(changed) {
			case 'monday':
			case 'tuesday':
			case 'wednesday':
			case 'thursday':
			case 'friday':
			if (dijit.byId(changed).attr("checked") == false) {
				dijit.byId('workingday').attr("checked",false);
			} else {
				if (dijit.byId('monday').attr("checked") == true &&
				dijit.byId('tuesday').attr("checked") == true &&
				dijit.byId('wednesday').attr("checked") == true &&
				dijit.byId('thursday').attr("checked") == true &&
				dijit.byId('friday').attr("checked") == true)

				dijit.byId('workingday').attr("checked",true);
			}

			break;
			case 'saturday':
			case 'sunday':
			if (dijit.byId(changed).attr("checked") == false) {
				dijit.byId('weekend').attr("checked",false);
			} else {
				if (dijit.byId('saturday').attr("checked") == true &&
				dijit.byId('sunday').attr("checked") == true)

				dijit.byId('weekend').attr("checked",true);
			}
			break;
			case 'weekend':
			dijit.byId('saturday').attr("checked",false);
			dijit.byId('sunday').attr("checked",false);

			if (dijit.byId(changed).attr("checked") == true) {
				dijit.byId('saturday').attr("checked",true);
				dijit.byId('sunday').attr("checked",true);
			}
			break;
			case 'workingday':
			dijit.byId('monday').attr("checked",false);
			dijit.byId('tuesday').attr("checked",false);
			dijit.byId('wednesday').attr("checked",false);
			dijit.byId('thursday').attr("checked",false);
			dijit.byId('friday').attr("checked",false);

			if (dijit.byId(changed).attr("checked") == true) {
				dijit.byId('monday').attr("checked",true);
				dijit.byId('tuesday').attr("checked",true);
				dijit.byId('wednesday').attr("checked",true);
				dijit.byId('thursday').attr("checked",true);
				dijit.byId('friday').attr("checked",true);
			}

			break;

		}
	} catch(e) {
		alert("handle_day_change: "+e);
	}
}

function reload_url(playerid, element_id) {
	try {
		var view = dijit.byId("view").attr("value");
		
		var galaxy   = (dijit.byId("act_galaxyview").attr("checked") == true) ? 1 : 0;
		var scans    = (dijit.byId("act_scans").attr("checked") == true) ? 1 : 0;
		var messages = (dijit.byId("act_messages").attr("checked") == true) ? 1 : 0;
		var combats  = (dijit.byId("act_combat_reports").attr("checked") == true) ? 1 : 0;
		var allypage = (dijit.byId("act_allypage").attr("checked") == true) ? 1 : 0;
		var manual   = (dijit.byId("act_manual").attr("checked") == true) ? 1 : 0;
		
		if (view == "day") {
			var monday     = (dijit.byId("monday").attr("checked") == true) ? true : false;
			var tuesday    = (dijit.byId("tuesday").attr("checked") == true) ? true : false;
			var wednesday  = (dijit.byId("wednesday").attr("checked") == true) ? true : false;
			var thursday   = (dijit.byId("thursday").attr("checked") == true) ? true : false;
			var friday     = (dijit.byId("friday").attr("checked") == true) ? true : false;
			var saturday   = (dijit.byId("saturday").attr("checked") == true) ? true : false;
			var sunday     = (dijit.byId("sunday").attr("checked") == true) ? true : false;
			var weekend    = (dijit.byId("weekend").attr("checked") == true) ? true : false;
			var workingday = (dijit.byId("workingday").attr("checked") == true) ? true : false;
		}
	
		if (dojo.byId('time_from').style.display == 'inline' && calendar_from_time != null) {
			var time_from = dojo.date.locale.format(calendar_from_time, {datePattern: 'yyyy-MM-dd', selector:'date'});
		} else {
			var time_from = ""
		}
		if (dojo.byId('time_to').style.display == 'inline' && calendar_to_time != null) {
			var time_to = dojo.date.locale.format(calendar_to_time, {datePattern: 'yyyy-MM-dd', selector:'date'});
		} else {
			var time_to = ""
		}

		var url = "ajax/ajax_activity_graph.php?playerid="+playerid+"&galaxy="+galaxy+"&scans="+scans+"&messages="+messages+"&combats="+combats+"&allypage="+allypage+"&manual="+manual+"&time_from="+time_from+"&time_to="+time_to;
		
		if (view == "day") {
			var days = "";

			if (monday == true)    days+= "1";
			if (tuesday == true)   days+= "2";
			if (wednesday == true) days+= "3";
			if (thursday == true)  days+= "4";
			if (friday == true)    days+= "5";
			if (saturday == true)  days+= "6";
			if (sunday == true)    days+= "7";

			url += "&days="+days;
		} else {
			url += "&weekview=true";
		}

		ShowObject(element_id,url,false);

	} catch(e) {
		alert("unexpected error at reload_url: "+e);
	}
}

function set_player_active(playerid) {
	var source_url = "ajax/ajax_activities.php";

	advAJAX.post({
		url : source_url,
		parameters : {
			"playerid"   : playerid,
			"set_active" : "true"
		},
		onSuccess : function(obj) {
			if ( obj.responseText == "true") {
				reload_url(playerid, 'act_graph');
			} else {
				alert("Unexpected response: " + obj.responseText);
			}

		},
		onError : function(obj) { alert("Error: " + obj.status);  }
	});
}

function set_player_activity(playerid) {
	var source_url = "ajax/ajax_activities.php";
	
	// get date
	var date = dojo.date.locale.format(dijit.byId("date").attr("value"), {datePattern: 'yyyy-MM-dd', selector:'date'});
	// get time
	var time_h = dijit.byId("time_h").attr("value");
	var time_m = dijit.byId("time_m").attr("value");
	
	if (date == "" || time_h == "" || time_m == "") return; // nothing to do
	
	advAJAX.post({
		url : source_url,
		parameters : {
			"playerid" : playerid,
			"date" : date,
			"time_h" : time_h,
			"time_m" : time_m
		},		
		onSuccess : function(obj) {
			if ( obj.responseText == "true") {
				reload_url(playerid, 'act_graph');
			} else {
				alert("Unexpected response: " + obj.responseText);
			}

		},
		onError : function(obj) { alert("Error: " + obj.status);  }
	});
}

function selection_changed(playerid) {
	var view = dijit.byId("view").attr("value");
	
	if (view == "week") {
		dojo.byId("day_selection").style.display = "none";
		reload_url(playerid, 'act_graph');
		
	} else {
		// 24h view
		dojo.byId("day_selection").style.display = "inline";
		reload_url(playerid, 'act_graph');
		
	}
	
}