/*
*
* Galaxytool Javascripts
* (c) 2005-2007 Christian Lehmann
* mail: webmaster@mathe-informatik.de
* www: http://www.galaxytool.eu
* --- requires galaxytool.js loaded ! ---
*/

/*
* Popup window with extra options
*/

/*
* This method stores all required information and calls the updateObjects() method
* after 100 milliseconds timeout.
*/
function ShowLocalObject(param_object,param_object_content) {
    param_object_content = decode_utf8(param_object_content);
    temp_object = param_object;
    document.getElementById(temp_object).innerHTML = param_object_content;
    content_open = false;
    timeout_start_mouse_x = mouse_x;
    timeout_start_mouse_y = mouse_y;
    window.clearTimeout(active);
    active = setTimeout("updateLocalObjects()",100);
}

function ShowObjectAtMouse(ObjectId) {
    if (mouse_y > document.getElementById(ObjectId).offsetHeight) {
        document.getElementById(ObjectId).style.top     = mouse_y-10- document.getElementById(ObjectId).offsetHeight;
    } else {
        document.getElementById(ObjectId).style.top     = mouse_y+10;
    }
    if (mouse_x > document.getElementById(ObjectId).offsetWidth) {
        document.getElementById(ObjectId).style.left    = mouse_x - 10 - document.getElementById(ObjectId).offsetWidth;
    } else {
        document.getElementById(ObjectId).style.left    = mouse_x + 10;
    }
    document.getElementById(ObjectId).style.display = 'inline';
}

/*
 * Use visiblity instead of display
 */
function ShowObjectAtMouse2(ObjectId) {
    if (mouse_y > document.getElementById(ObjectId).offsetHeight) {
        document.getElementById(ObjectId).style.top     = mouse_y-10 - document.getElementById(ObjectId).offsetHeight;
    } else {
        document.getElementById(ObjectId).style.top     = mouse_y+10;
    }
    if (mouse_x > document.getElementById(ObjectId).offsetWidth) {
        document.getElementById(ObjectId).style.left    = mouse_x - 10 - document.getElementById(ObjectId).offsetWidth;
    } else {
        document.getElementById(ObjectId).style.left    = mouse_x + 10;
    }
    document.getElementById(ObjectId).style.visibility = 'visible';
}


function encode_utf8(rohtext) {
    // dient der Normalisierung des Zeilenumbruchs
    rohtext = rohtext.replace(/\r\n/g,"\n");
    var utftext = "";
    for(var n=0; n<rohtext.length; n++)
    {
        // ermitteln des Unicodes des  aktuellen Zeichens
        var c=rohtext.charCodeAt(n);
        // alle Zeichen von 0-127 => 1byte
        if (c<128)
        utftext += String.fromCharCode(c);
        // alle Zeichen von 127 bis 2047 => 2byte
        else if((c>127) && (c<2048)) {
            utftext += String.fromCharCode((c>>6)|192);
            utftext += String.fromCharCode((c&63)|128);}
            // alle Zeichen von 2048 bis 66536 => 3byte
            else {
                utftext += String.fromCharCode((c>>12)|224);
                utftext += String.fromCharCode(((c>>6)&63)|128);
                utftext += String.fromCharCode((c&63)|128);}
    }
    return utftext;
}

function decode_utf8(utftext) {
    var plaintext = ""; var i=0; var c=c1=c2=0;
    // while-Schleife, weil einige Zeichen uebersprungen werden
    while(i<utftext.length)
    {
        c = utftext.charCodeAt(i);
        if (c<128) {
            plaintext += String.fromCharCode(c);
            i++;}
            else if((c>191) && (c<224)) {
                c2 = utftext.charCodeAt(i+1);
                plaintext += String.fromCharCode(((c&31)<<6) | (c2&63));
                i+=2;}
                else {
                    c2 = utftext.charCodeAt(i+1); c3 = utftext.charCodeAt(i+2);
                    plaintext += String.fromCharCode(((c&15)<<12) | ((c2&63)<<6) | (c3&63));
                    i+=3;}
    }
    return plaintext;
}

/*
* If the mouse is still in valid range (+-20 px of mouseoverpos)
* check if the content was loaded before and make it visible again
* otherwise load the content and make it visible
*/
function updateLocalObjects() {
    // if object is already opened, quit
    if (content_open == true) {
        return;
    }

    window.clearTimeout(active);

    removeObjects();

    // check if mouse was moved during timeout
    if ( mouse_x < timeout_start_mouse_x - 20 || mouse_x > timeout_start_mouse_x + 20 ||
    mouse_y < timeout_start_mouse_y - 20 || mouse_y > timeout_start_mouse_y + 20 ) {
        return;
    }

    // determine position of object
    // check if content was already loaded
    document.getElementById(temp_object).style.display = "inline";
    if (mouse_y > document.getElementById(temp_object).offsetHeight) {
        document.getElementById(temp_object).style.top     = mouse_y-10- document.getElementById(temp_object).offsetHeight;
    } else {
        document.getElementById(temp_object).style.top     = mouse_y+10;
    }
    if (mouse_x > document.getElementById(temp_object).offsetWidth) {
        document.getElementById(temp_object).style.left    = mouse_x - 10 - document.getElementById(temp_object).offsetWidth;
    } else {
        document.getElementById(temp_object).style.left    = mouse_x + 10;
    }
    current_object = temp_object;
    content_open = true;
}

/*
* Hide, Unhide a given object by setting the diplay attribute to inline or none
* display: none, block, inline,  list-item, run-in, compact, table, inline-table,
*/
function hideUnhideObject(temp_object) {
    try {
        if (navigator.userAgent.search(/msie/i) != -1) {
            // IE
            var element = "block";
        } else {
            // kein IE
            var element = "table";
        }

        if ( document.getElementById(temp_object).style.display == element ||  document.getElementById(temp_object).style.display == "inline") {
            document.getElementById(temp_object).style.display = "none";
        } else {
            document.getElementById(temp_object).style.display = element; //  table (FF), block (IE)
        }
    } catch(e) {
        alert("Fehler: "+e);
    }
}