<?php
header("content-type: text/html; charset=utf-8");
session_start();

include "logincheck.inc.php";
if (!$_SESSION['s_probeview']) {
	$error_page_code = "permission";
	include "errorpage.php";
	exit();
}
require "languages.php";
require "../config/config.php";
require "../config/attributes.php";
require_once "functions.inc.php";
require "parser_reports.inc.php";

$probe_lang = new ProbeLanguages(); // to load language files
$top_array = $probe_lang->get_flipped_top_array();
$probe_array = $probe_lang->get_flipped_probe_array();
$db_array = array_flip(ReportParser::$db_array);

$db_key_to_text = array();
foreach ($db_array as $db_key => $en_value) {
	$db_key_to_text[$db_key] = $probe_array[$en_value];
}

$head_css = '
<style type="text/css">
.dojoxGridHeader {
	visibility:hidden;
	position: absolute;
	overflow: hidden;
	cursor: default;
	height: 0px;
}
</style>
<script type="text/javascript" src="https://www.google.com/jsapi"></script>
';

makeheader(REPORT_ARCHIVE_TITLE, true, $head_css);

if (!isset($_GET['coordinates'])) {
	exit();
}

$coordinates = $_GET['coordinates'];
$coords = explode(":",$coordinates);
if (count($coords) != 3) exit("Wrong coordinates");
foreach ($coords as &$coordinate) {
	$coordinate = intval($coordinate);
}

$coordinates = $coords[0].":".$coords[1].":".$coords[2];
if (preg_replace("/\d+\:\d+\:\d+/","",$coordinates) == "") {
	$store_url = "ajax/ajax_report_archive.php?type=coordinates&coordinates=$coordinates";
}
$moon = (isset($_GET['moon']) && $_GET['moon'] == "true") ? "true" : "false";
$store_url .= "&moon=$moon";

if (!isset($store_url)) $store_url = "ajax/ajax_report_archive.php?type=empty";

// get playername and planetname if available (might not be available if cleanup scripts were not executed)
$query = "SELECT planetname, playername, p.id FROM $dbtablename g, $playertable p ".
         "WHERE g.player_id = p.id AND g.galaxy=".$coords[0]." AND g.system=".$coords[1]." AND g.planet=".$coords[2]."";
$res = mysql_query($query,$global_mysql_con) or die($query."<br>".mysql_error());

$playername = "";
$planetname = "";
if (mysql_num_rows($res) > 0) {
	$line = mysql_fetch_object($res);
	$playername = $line->playername;
	$planetname = $line->planetname;
	$playerid   = $line->id;
}
echo '
<script type="text/javascript">
var resources_on_text = "'.$top_array["Resources at"].'";
var archive_confirm_delete = "'.REPORT_ARCHIVE_CONFIRM_DELETE.'";
var report_coordinates = "'.$coordinates; if($moon == "true") echo " M"; echo '";
var report_when = "'.$probe_lang->report_when.'";
var galaxytool_is_moon = '.$moon.';

var galaxytool_language = "'.$_SESSION['lang'].'";
var galaxytool_techs = {
	vbt : '.$_SESSION['s_vbt'].',
	impulse : '.$_SESSION['s_impulse'].',
	hra : '.$_SESSION['s_hra'].',
	waffentech : '.$_SESSION['s_waffentech'].',
	schildtech : '.$_SESSION['s_schildtech'].',
	rpz : '.$_SESSION['s_rpz'].'
};
var galaxytool_def_to_debris = '; echo ($def_to_debris) ? 'true' : 'false'; echo ';
var galaxytool_debris_rate = "'.$debris_rate.'";

var galaxytool_speedsim_text = "'.REPORTS_SPEEDSIM.'";
var galaxytool_dragosim_text = "'.REPORTS_DRAGOSIM.'";
var galaxytool_cargo_capacity_text = "'.REPORT_ARCHIVE_FLEET_CARGO.'";
var galaxytool_phalanx_text = "'.DETAILEDINFO_PHALANX_AREA.'";
var galaxytool_irak_text = "'.REPORT_ARCHIVE_IRAK_RANGE.'";
var galaxytool_delete = '; echo ($_SESSION['s_candelete']) ? 'true' : 'false'; echo ';
</script>
';
?>
<span dojoType="dojo.data.ItemFileReadStore" jsId="store1" url="<?php echo $store_url; ?>"> </span>
<div class="firstcolor startsHidden" style="width: 100%; margin: 0 0 0 20;">
	<div class="tblhead" style="height: 30px; width: 100%; font-size: 10pt;">
	<?php
	if ($planetname != "" && $playername != "") {
		$string = REPORT_ARCHIVE_DETAILS_FOR;
		$string = str_replace("&1",$planetname,$string);
		$string = str_replace("&2",
					'<a style="font-size:10pt; font-weight:bold;" href="view.php?gala='.$coords[0].'&system='.$coords[1].'">'.$coordinates."</a>",
					$string);
		$string = str_replace("&3",
					'<a style="font-size:10pt; font-weight:bold;" href="playerinformation.php?id='.$playerid.'">'.$playername."</a>",
					$string);
		echo $string;
		if($moon == "true") echo " M";
	} else {
		echo REPORT_ARCHIVE_COORDINATES." ".$coordinates;  if($moon == "true") echo " M";
	}
	 ?>
	</div>
	<?php
	echo '
	<div style="margin-top: 10px; margin-left: 20px;">';
	if ($_SESSION['s_candelete']) {
		echo '
		<button dojoType="dijit.form.Button" type="button" id="delete_report" disabled="false" iconClass="trashicon"
			showLabel="false" onClick="galaxytool_archive_delete()">'.REPORT_ARCHIVE_DELETE.'</button>
			';
	}
	echo '
			&nbsp;&nbsp;&nbsp;&nbsp;'.REPORT_ARCHIVE_CHART_TYPE.':
		<select name="select" dojoType="dijit.form.Select" id="chart_type" jsId="chart_type" style="width:175px">
			<option value="annotetedtimeline">AnnotatedTimeLine (Flash)</option>
			<option value="linechart">LineChart</option>
		</select>
		<button dojoType="dijit.form.Button" type="button" id="show_graph" disabled="false" iconClass="magnifiericon"
			showLabel="false" onClick="galaxytool_drawChart()">'.REPORT_ARCHIVE_DETAILS.'</button>
	</div>
	';
	?>
	<table dojoType="dojox.grid.DataGrid" id="grid1" jsId="grid1" store="store1"
		rowsPerPage="100" autoHeight="100">
		<thead>
			<tr>
				<th width="150px" field="c0" formatter="galaxytool_archive_formatter">&nbsp;</th>
				<th width="75px" field="c1" formatter="galaxytool_archive_formatter2">&nbsp;</th>
				<th width="75px" field="c2" formatter="galaxytool_archive_formatter2">&nbsp;</th>
				<th width="75px" field="c3" formatter="galaxytool_archive_formatter2">&nbsp;</th>
				<th width="75px" field="c4" formatter="galaxytool_archive_formatter2">&nbsp;</th>
			</tr>
		</thead>
	</table>
</div>
<div id="ChartDialog" dojoType="dijit.Dialog" title="<?php echo REPORT_ARCHIVE_DETAILS.": $coordinates"; if($moon == "true") echo " M"; ?>">
    <div dojoType="dijit.layout.ContentPane" title="" style="width: 700px; height: 400px;">
            ...
    </div>
</div>
<div id="ReportDialog" dojoType="dijit.Dialog" style="width: 540px;" title="<?php echo REPORT_ARCHIVE_DETAILS.": $coordinates"; if($moon == "true") echo " M"; ?>">
    <div dojoType="dijit.layout.ContentPane" title="">
            ...
    </div>
</div>

<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/dojo/1.6.1/dojo/dojo.xd.js"
	djConfig="parseOnLoad: true">
</script>
<script type="text/javascript" src="javascript/report_display.js">
</script>
<script type="text/javascript" src="javascript/report_archive.js">
</script>
<?php
makefooter(true);
?>